<?php

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/acs_vue');

function controleurs_var_dist($regs) {
	global $spip_lang;
	include_spip('inc/filtres');
	include_spip('inc/composant/classControles');
	include_spip('inc/composant/composants_variables');

	$cv = composants_variables();
	list(, $crayon, $type, $champ, $id) = $regs;
	$v = explode('_', $champ);
	$c = $v[0]; // composant
	$v = $v[1]; // variable
	$val = acs_get('acs' . ucfirst($c) . ($id ? $id : '') . $v);
	$type = $cv[$c]['vars'][$v]['type'];

	// il faut passer champ=>source pour les comparaisons dans action/crayons_store
	$crayon = new SecureCrayon('var-' . $champ . '-' . $id, [$champ => $val]);

	$ctl_name = 'ctl' . ucfirst($type);
	if (class_exists($ctl_name)) {
		$ctl = new $ctl_name($c, ($id ? $id : ''), $v, $val, $cv[$c]['vars'][$v]);
	}
	else {
		// On dessine un controle Textarea si le type est inconnu
		$ctl = new ctlTextarea($c, ($id ? $id : ''), $v, $val, $cv[$c]['vars'][$v]);
	}

	$html .= '<div class="acsVarControleur" style="width:' .
		($crayon->w + 5) . 'px; height:auto; font-size: ' . _request('font-size') . ';">' .
		'<form id="acs" name="acs" class="formulaire_crayon" action="?action=crayons_var_store" method="post">' .
		$crayon->code() .
		'<input type="hidden" name="oldval' . '" value="' . htmlentities($val) . '" />' .
		'<input type="hidden" name="type' . '" value="' . $type . '" />' .
		'<input type="hidden" name="var_mode" value="recalcul" />' .
		$ctl->draw() .
		'<span>' . crayons_boutons() . '</span></form>';
	return [$html, null];
}
