<?php

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * Lit la liste des jeux de composants du plugin
 * @param array plugin metas
 * @return array {plugin, version, set, dir, slogan, description}
 */
function acs_get_sets($p) {
	// Pas les plugins dist
	if ($p['dir_type'] != '_DIR_PLUGINS') {
		return false;
	}
	$squelettes = [];
	$dir_sets = '../plugins/' . $p['dir'] . '/sets';
	if ($d = @opendir($dir_sets)) {
		while (false !== ($file = @readdir($d))) {
			$nom = $file;
			$slogan = '';
			$descr = '';
			$set = $dir_sets . '/' . $file;
				if ($file != '..' && substr($file, 0, 1) != '.' && @is_dir($set)) {
					$paq = $set . '/paquet.xml';
						if (is_file($paq)) {
							$langfile = $set . '/lang/paquet-' . $file . '_' . $GLOBALS['spip_lang'];
							if (is_file($langfile . '.php')) {
								require $langfile. '.php';
							}
							$nom = $GLOBALS[$GLOBALS['idx_lang']][$file . '_nom'];
							$nom = $nom ? $nom : $file;
							$slogan = $GLOBALS[$GLOBALS['idx_lang']][$file . '_slogan'];
							$descr = $GLOBALS[$GLOBALS['idx_lang']][$file . '_description'];
						}
						$squelettes[] = [
							'plugin' => $p['nom'],
							'version' => $p['version'],
							'nom_set' => $nom,
							'set' => $file,
							'dir' => $dir_sets,
							'slogan' => $slogan,
							'description' => $descr
						];
				}
		}
		closedir($d);
		natsort($squelettes);
		return $squelettes;
	}
	else {
		return false;
	}

	return ['' => $dir_sets . ' ' . _DIR_ACS];
}

/**
 * Traitement post du formulaire formulaires/f_cfg_acs_set.html
 * @return array
 */
function formulaires_f_cfg_acs_set_traiter_dist() {
		//refuser_traiter_formulaire_ajax(); // a debugguer because pb reset.css
		if (
			(acs_get('ACS_SET') != _request('ACS_SET')) ||
			(acs_get('ACS_OVER') != _request('ACS_OVER'))
		) {
			acs_set('ACS_SET', _request('ACS_SET'));
			acs_set('ACS_OVER', _request('ACS_OVER'));
			$GLOBALS['dossier_squelettes'] = (acs_get('ACS_OVER') ? acs_get('ACS_OVER') . ':' : '') . _DIR_ACS . 'sets/' . _request('ACS_SET');
			acs_recalcul();
			return ['message_ok' => _T('plugin_info_upgrade_ok')];
		}
}
